/*	
 *	frampsg.h
 *
 *	P/ECE PSG(AY-3-8910) Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2003 Naoyuki Sawa
 *
 *	* Sat Nov 22 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *
 ****************************************************************************/

void
psg_mix(PSG* psg, short wbuff[/*PSGBUFLEN*/])
{
	static char mixbuf[PSGBUFLEN]; /* ~LVOobt@Ars`shbłI */

	PSGINFO info;
	PSGCHANNEL* channel;
	unsigned char* preg;
	         char* pmix;
	        short* pout;
	int i, n1, n2, i_channel, frequency, volume;
	int progress, dda_d;
	div_t dda_v;

	/* ܂A~LVOobt@NA܂B */
	memset(mixbuf, 0, sizeof mixbuf);

	/* PSGWX^ǂݍ݂܂B */
	preg = psg->reg;
	/* [R0-1] */
	n1 = *preg++;
	n2 = *preg++;
	info.channel[0].tone_period = n1 | (n2 & 0x0f) << 8;
	/* [R2-3] */
	n1 = *preg++;
	n2 = *preg++;
	info.channel[1].tone_period = n1 | (n2 & 0x0f) << 8;
	/* [R4-5] */
	n1 = *preg++;
	n2 = *preg++;
	info.channel[2].tone_period = n1 | (n2 & 0x0f) << 8;
	/* [R6] */
	n1 = *preg++;
	info.noise_period = n1 & 0x1f;
	/* [R7] */
	n1 = *preg++;
	info.channel[0].tone_noise_enable = !(n1 & 0x01) | !(n1 & 0x08) << 1; /* v!![R7]̃rbg0:ON/1:OFFł */
	info.channel[1].tone_noise_enable = !(n1 & 0x02) | !(n1 & 0x10) << 1; /* v!![R7]̃rbg0:ON/1:OFFł */
	info.channel[2].tone_noise_enable = !(n1 & 0x04) | !(n1 & 0x20) << 1; /* v!![R7]̃rbg0:ON/1:OFFł */
	/* [R8] */
	n1 = *preg++;
	info.channel[0].amplitude_mode = (n1 & 0x10) >> 4;
	info.channel[0].amplitude_level = n1 & 0x0f;
	/* [R9] */
	n1 = *preg++;
	info.channel[1].amplitude_mode = (n1 & 0x10) >> 4;
	info.channel[1].amplitude_level = n1 & 0x0f;
	/* [R10] */
	n1 = *preg++;
	info.channel[2].amplitude_mode = (n1 & 0x10) >> 4;
	info.channel[2].amplitude_level = n1 & 0x0f;
	/* [R11-12] */
	n1 = *preg++;
	n2 = *preg++;
	info.envelope_period = n1 | n2 << 8;
	/* [R13] */
	n1 = *preg++;
	info.envelope_shape_cycle = n1 & 0x0f;

	/* PSGdlFGx[vg̓NbN256Gx[vsIhl */
	/* TODO: */

	/* e`l̃g[B */
	for(i_channel = 0, channel = info.channel; i_channel < 3; i_channel++, channel++) {
		if(channel->tone_noise_enable & 1/*TONE*/) {
			/* PSGdlFg[g̓NbN16g[sIhl */
			frequency = (psg->clock >> 4) / (channel->tone_period ? channel->tone_period : 1);
			volume = channel->amplitude_level;
			/*{{DDA*/
			progress = psg->tone_progress[i_channel];
			dda_d = psg->tone_dda_d[i_channel];
			dda_v = div(frequency, SPEAKER_FREQUENCY / 2);
			/*}}DDA*/
			for(i = 0, pmix = mixbuf; i < PSGBUFLEN; i++, pmix++) {
				if(progress & 1) {
					*pmix += volume;
				} else {
					*pmix -= volume;
				}
				/*{{DDAXebv*/
				progress += dda_v.quot;
				dda_d += dda_v.rem;
				while(dda_d >= 0) {
					dda_d -= SPEAKER_FREQUENCY / 2;
					progress++;
				}
				/*}}DDAXebv*/
			}
			/*{{DDAЕt*/
			psg->tone_progress[i_channel] = progress;
			psg->tone_dda_d[i_channel] = dda_d;
			/*}}DDAЕt*/
		}
	}

	/* mCYB */
	volume = 0;
	for(i_channel = 0, channel = info.channel; i_channel < 3; i_channel++, channel++) {
		if(channel->tone_noise_enable & 2/*NOISE*/) {
			volume += channel->amplitude_level;
		}
	}
	if(volume) {
		/* PSGdlFmCYώg̓NbN16mCYsIhl */
		frequency = (psg->clock >> 4) / (info.noise_period ? info.noise_period : 1);
		/*{{DDA*/
		progress = psg->noise_progress;
		dda_d = psg->noise_dda_d;
		dda_v = div(frequency, SPEAKER_FREQUENCY / 256/*mCYe[uTCY*/);
		/*}}DDA*/
		for(i = 0, pmix = mixbuf; i < PSGBUFLEN; i++, pmix++) {
			*pmix += (psg_noise_table[progress & 0xff/*mCYe[uTCY-1*/] * volume) >> 7; /* TODO: HW~HWɂč */
			/*{{DDAXebv*/
			progress += dda_v.quot;
			dda_d += dda_v.rem;
			while(dda_d >= 0) {
				dda_d -= SPEAKER_FREQUENCY / 256/*mCYe[uTCY*/;
				progress++;
			}
			/*}}DDAXebv*/
		}
		/*{{DDAЕt*/
		psg->noise_progress = progress;
		psg->noise_dda_d = dda_d;
		/*}}DDAЕt*/
	}

	/* ~LVOobt@(32rbg)o̓obt@(16rbg)փRs[܂B */
	for(i = 0, pmix = mixbuf, pout = wbuff; i < PSGBUFLEN; i++, pmix++, pout++) {
		volume = *pmix << 10;	/* 32767/(15*3)=728=>1024A */
		     if(volume < -32767) volume = -32767;
		else if(volume >  32767) volume =  32767;
		*pout = volume;
	}
}
